<script setup lang="ts">
import { RouterView, useRouter } from 'vue-router'
import AppNavBar from './components/AppNavBar.vue'
import AppFooter from './components/AppFooter.vue'
import { GlobalError, useAppStore } from './stores/app'
import { useI18n } from 'vue-i18n'
import GlobalErrorModal from '@/components/GlobalErrorModal.vue'
import GlobalReportModal from '@/components/GlobalReportModal.vue'

const router = useRouter()
const app = useAppStore()
const i18n = useI18n()

function updateLocale(locale: 'en' | 'fr') {
  i18n.locale.value = locale
}

app.$onAction(({ name, store, after }) => {
  if (name === 'setLocale') {
    after(() => {
      updateLocale(store.locale)
    })
  } else if (name === 'handleAuthFailure') {
    after(() => {
      router.push({ path: '/' }).then(() => {
        app.setGlobalError(GlobalError.AuthenticationFailed)
      })
    })
  }
})

updateLocale(app.locale)
</script>

<template>
  <AppNavBar />
  <GlobalErrorModal />
  <GlobalReportModal />
  <RouterView />
  <AppFooter />
</template>
